package AERPP;

import java.util.ArrayList;

public class LinkedCause {
	
	private int numberOfCause;
	private ArrayList<Integer> coverCause;
	private int[] coverCauseIndicator;
	private int[] connectionToRest;
	private ArrayList<Integer> coverOb;
	private int id;
	private int[] ai;
	private double c;
	private ArrayList<Integer> potentialExpand;
	
	public LinkedCause(int numberOfCause, int numberofOb, ArrayList<Integer> coverCause, double c, ArrayList<Integer> coverOb,int[] connectionToRest) {
		super();
		this.numberOfCause =numberOfCause;
		this.c=c;
		this.coverOb=coverOb;
		this.coverCause=coverCause;
		this.ai=new int[connectionToRest.length];
		for (Integer cause:coverCause){
			id+=(int) Math.pow(2, cause);
			ai[cause]=1;
		}
		this.connectionToRest=connectionToRest;
		this.potentialExpand=new ArrayList<Integer>();
		for (int i=0;i<connectionToRest.length;i++){
			if (ai[i]==0&&connectionToRest[i]>0){
				potentialExpand.add(i);
			}
		}
		this.coverCauseIndicator=new int[numberOfCause];
		for (Integer cc:coverCause){
			coverCauseIndicator[cc]=1;
		}
	//	System.out.println("id:"+id);
	}

	public int getNumberOfCause() {		
		return numberOfCause;
	}

	public void setNumberOfCause(int numberOfCause) {
		this.numberOfCause = numberOfCause;
	}

	public double getC() {
		return c;
	}

	public void setC(double c) {
		this.c = c;
	}

	public ArrayList<Integer> getCoverOb() {
		return coverOb;
	}

	public void setCoverOb(ArrayList<Integer> coverOb) {
		this.coverOb = coverOb;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int[] getConnectionToRest() {
		return connectionToRest;
	}

	public void setConnectionToRest(int[] connectionToRest) {
		this.connectionToRest = connectionToRest;
	}

	public ArrayList<Integer> getCoverCause() {
		return coverCause;
	}

	public void setCoverCause(ArrayList<Integer> coverCause) {
		this.coverCause = coverCause;
	}

	public int[] getAi() {
		return ai;
	}

	public void setAi(int[] ai) {
		this.ai = ai;
	}

	public ArrayList<Integer> getPotentialExpand() {
		return potentialExpand;
	}

	public void setPotentialExpand(ArrayList<Integer> potentialExpand) {
		this.potentialExpand = potentialExpand;
	}

	public int[] getCoverCauseIndicator() {
		return coverCauseIndicator;
	}
	
}
